function varargout = undof_b(varargin)
% UNDOF_B Application M-file for undof_b.fig
%    FIG = UNDOF_B launch undof_b GUI.
%    UNDOF_B('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 17-May-2004 17:25:09

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end
    
    %%% ***ALEX********************************
	%%% begin initialization....
	%%%
	%%%
    data = handles;
    
	data.stop  = 0;

	
	% s = stato del punto, vettore colonna [posizione; velocit]  
	%      (qui inizializzato per condizioni iniziali)
	
	data.s    = [ 1.0;    % x, pos
                   0.0 ];    % v, vel
	
	% ms_dt = derivata dello stato, vettore colonna [velocit; accelerazione]
	%         (dipender istante per istante dalle forze agenti)
	
	data.s_dt = [0; 
                  0];
	
	% massa
	data.M = 0.3;
	
	% rigidezza
	data.k = 8.0;   
	
	% smorzamento
	data.r = 0.3;
	
	% offset punto di ancoraggio
	data.d = 0.0;
	
	% tempo corrente
	data.t =0;
	
	% tempo di fine simulazione
	data.t_end = 8; 
	
	% step di integrazione
	data.step = 0.002;
	
	% max numero di punti da disegnare
	data.maxindex = 2000;
	
	data.span = data.maxindex*data.step;
	
    set(fig, 'ToolBar', 'figure');
    
    
	set(data.axes_plot, 'XLim', [0,data.span], 'XLimMode','manual', ...
                        'YLim', [-2, +2], 'YLimMode','manual');
    
            % metti tre linee nel plot in basso
    axes(data.axes_plot); 
    xlabel('time');
    data.figGlPos = line('Color', [0 0 1], 'XData',[], 'YData',[]); % position graph
    data.figGlCt = line('Color', [0.4 0.4 0.4], 'XData',[], 'YData',[]); % constraint imposed position graph
    ml = legend('x [m]', 'C [m]'); set (ml, 'FontSize', 7, 'Box','off', 'XColor',[1 1 1], 'YColor',[1 1 1]);
    
    axes(data.axes_vel);
    xlabel('');
    data.figGlVel = line('Color', [0 1 0], 'XData',[], 'YData',[]); % speed graph
    ml = legend('v [m/s]'); set (ml, 'FontSize', 7, 'Box','off', 'XColor',[1 1 1], 'YColor',[1 1 1]);
    
    axes(data.axes_acc);
    xlabel('');
    data.figGlAcc = line('Color', [1 0 0], 'XData',[], 'YData',[]); % accel graph
    ml = legend('a [m/ss]'); set (ml, 'FontSize', 7, 'Box','off', 'XColor',[1 1 1], 'YColor',[1 1 1]);
    
    axes(data.axes_force);
    xlabel('');
    data.figGlFms  =line('Color', [0.5 0 0], 'XData',[], 'YData',[]); % springdamper force graph
    data.figGlFt   =line('Color', [0 0.5 0], 'XData',[], 'YData',[]); % imposed force graph
    ml = legend('Fkr [N]', 'F(t) [N]'); set (ml, 'FontSize', 7, 'Box','off', 'XColor',[1 1 1], 'YColor',[1 1 1]);

            % metti disegnini nel grafico dell'animazione, in alto
    axes(data.axes_animation); 
    data.fig_wall   = line('Color', [0 0 0], 'XData',[], 'YData',[], 'LineWidth',3);
    data.fig_spring = line('Color', [0.2 0.3 0.3], 'XData',[], 'YData',[], 'LineWidth',2);
    data.fig_box    = patch([0 .6 .6 0],[0 0 .4 .4],[0 0 0 0], 'r');
    data.fig_floor  = patch([-2 +2 +2 -2],[0 0 -.1 -.1],[0 0 0 0], 'b');
	
           
            % Update handles structure
	guidata(fig, data);
  
    
    data_to_gui(data);

	%%%
	%%%
	%%% end initialization
	%%% ***ALEX********************************
    

    

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
	catch
		disp(lasterr);
	end

end





% --------------------------------------------------------------------
%  
function data_to_gui(handles)

set (handles.edit_integration_step, 'String', sprintf('%0.3f',handles.step)  );
set (handles.edit_end_time,         'String', sprintf('%0.3f',handles.t_end)  );
set (handles.edit_pos0,             'String', sprintf('%0.3f',handles.s(1))  );
set (handles.edit_vel0,             'String', sprintf('%0.3f',handles.s(2))  );
set (handles.edit_mass,             'String', sprintf('%0.3f',handles.M)  );
set (handles.edit_stiffness,        'String', sprintf('%0.3f',handles.k)  );
set (handles.edit_damping,          'String', sprintf('%0.3f',handles.r)  );
set (handles.edit_visible_time,     'String', sprintf('%0.3f',handles.span)  );




%| ABOUT CALLBACKS:




% --------------------------------------------------------------------
function varargout = push_start_Callback(h, eventdata, data, varargin)


data.stop=0;
data.t = 0;
guidata(h, data); % store the changes...
 
t0= clock;
index = 1;
update = 0;
update_each = 20;

while (data.t < data.t_end)
    
    % Prima di iniziare i conti importanti, usa la funzione 'eval' di
    % Matlab per calcolare le funzioni (se ci sono) che l'untente ha inserito per
    % esprimere la variazione di F col tempo o lo spostamento del vincolo...
    t = data.t;
    x = data.s(1);
    v = data.s(2); 
    C=0; F=0; % defaults;
    eval([get(data.edit_Ft,'String'),';'],'F=0;');    % valuta user-defined function F =..
    eval([get(data.edit_Ct,'String'),';'],'C=0;');    % valuta user-defined function C = ..
    data.ct = C;
    data.ft = F;
    
    % Calcola derivata della prima componente del vettore stato (pos->vel)
    % Facile: la velocit era gi la seconda componente del vettore stato!
   data.s_dt(1) = data.s(2);
    
    % Calcola derivata della seconda componente del vettore stato (vel->acc)
    % IMPORTANTE! QUI CALCOLO L'ACCELERAZIONE del corpo, date le forze agenti!
   allung_molla       = data.s(1) - data.d - data.ct;
   forza_molla        = - allung_molla * data.k;
   veloc_smorzatore   = data.s(2);
   forza_smorzatore   = - veloc_smorzatore * data.r;
   forza_ms = (forza_molla + forza_smorzatore);
   
   data.s_dt(2) = (1/data.M)* (forza_ms+data.ft);  % <-- ACCELERAZIONE!
  
    % Salva alcuni dati in vettori   
   if index>data.maxindex
       index=data.maxindex;
       v_pos=v_pos(2:(data.maxindex));
       v_vel=v_vel(2:(data.maxindex));
       v_acc=v_acc(2:(data.maxindex));
       v_tem=v_tem(2:(data.maxindex));
       v_fms =v_fms (2:(data.maxindex));
       v_ft  =v_ft (2:(data.maxindex));
       v_ct  =v_ct (2:(data.maxindex));
   end
   v_pos(index)  = data.s(1);
   v_vel(index)  = data.s(2);
   v_acc(index)  = data.s_dt(2);
   v_tem(index)  = data.t;
   v_fms(index) = forza_ms;
   v_ft(index) = data.ft;
   v_ct(index) = data.ct;
   index = index +1;
   update = update +1;

   
    % Ridisegna i grafici mentre l'integrazione prosegue, ma solo ogni 50 step di
    % integrazione, per maggiore velocit
   if update > update_each  
        update = 0;
        set (data.figGlPos, 'XData',v_tem, 'YData',v_pos);
        set (data.figGlVel, 'XData',v_tem, 'YData',v_vel);
        set (data.figGlAcc, 'XData',v_tem, 'YData',v_acc);
        set (data.figGlFms, 'XData',v_tem, 'YData',v_fms);
        set (data.figGlFt,  'XData',v_tem, 'YData',v_ft);
        set (data.figGlCt,  'XData',v_tem, 'YData',v_ct);
        set (data.axes_plot, 'Xlim',  [v_tem(1), v_tem(1)+data.span]);
        set (data.axes_acc, 'Xlim',   [v_tem(1), v_tem(1)+data.span]);
        set (data.axes_vel, 'Xlim',   [v_tem(1), v_tem(1)+data.span]);
        set (data.axes_force , 'Xlim', [v_tem(1), v_tem(1)+data.span]);
        if index>data.maxindex
            set(data.axes_plot, 'YLimMode','manual' );
            set(data.axes_acc,  'YLimMode','manual' );
            set(data.axes_vel, 'YLimMode','manual' );
            set(data.axes_force, 'YLimMode','manual' );
        end
        
        set (data.fig_box, 'XData', [data.s(1), data.s(1)+0.6, data.s(1)+0.6, data.s(1)], 'YData', [0, 0, 0.5,0.5]); 
        lm = x-C;
        set (data.fig_wall, 'XData', [C, C], 'YData',[0 0.9] );
        set (data.fig_spring, 'XData', [C,   C+0.2*lm, C+0.3*lm, C+0.4*lm, C+0.5*lm, C+0.6*lm, C+0.7*lm, C+0.8*lm, C+lm],...
                              'YData', [0.5, 0.5 ,     0.7,      0.4,      0.7,      0.4,      0.7,      0.5,      0.5] );
        
        drawnow;
        mrealtimestep = etime(clock,t0);
        if mrealtimestep < update_each*data.step
            pause (update_each*data.step - mrealtimestep);
        end
        t0 = clock;  
        
        mda= guidata(h);
        if (mda.stop)
            break;
        end;
   end
    
    % Applica formula di Eulero per integrare e proseguire con integrazione:
   s_new = data.s + data.s_dt * data.step;
   
    % Aggiorna lo stato...
   data.s = s_new;
   
    % Incrementa il tempo, e ripeti un altro step.....
   data.t = data.t + data.step;
   

end








% --------------------------------------------------------------------
function varargout = push_stop_Callback(h, eventdata, handles, varargin)

    handles.stop=1;
    guidata(h, handles); % store the changes...



    
% --------------------------------------------------------------------
function varargout = edit_integration_step_Callback(h, eventdata, handles, varargin)

newval = str2double(get(handles.edit_integration_step,'String'));
if isnan(newval),newval=0.002; set(handles.edit_integration_step,'String',num2str(newval));end
handles.step = newval;

% Update handles structure
guidata(h, handles);


% --------------------------------------------------------------------
function varargout = edit_end_time_Callback(h, eventdata, handles, varargin)

newval = str2double(get(handles.edit_end_time,'String'));
if isnan(newval),newval=4.0; set(handles.edit_end_time,'String',num2str(newval));end
handles.t_end = newval;

% Update handles structure
guidata(h, handles);


% --------------------------------------------------------------------
function varargout = edit_visible_time_Callback(h, eventdata, handles, varargin)

newval = str2double(get(handles.edit_visible_time,'String'));
if isnan(newval),newval=4.0; set(handles.edit_visible_time,'String',num2str(newval));end
handles.maxindex = ceil (newval/handles.step) +2;
handles.span = newval;
set(handles.axes_plot, 'XLim', [0,handles.span], 'XLimMode','manual')
set(handles.axes_vel, 'XLim', [0,handles.span], 'XLimMode','manual')
set(handles.axes_acc, 'XLim', [0,handles.span], 'XLimMode','manual')
set(handles.axes_force, 'XLim', [0,handles.span], 'XLimMode','manual')
% Update handles structure
guidata(h, handles);


% --------------------------------------------------------------------
function varargout = edit_pos0_Callback(h, eventdata, handles, varargin)

newval = str2double(get(handles.edit_pos0,'String'));
if isnan(newval),newval=0.0; set(handles.edit_pos0,'String',num2str(newval));end
handles.s(1) = newval;

% Update handles structure
guidata(h, handles);



% --------------------------------------------------------------------
function varargout = edit_vel0_Callback(h, eventdata, handles, varargin)

newval = str2double(get(handles.edit_vel0,'String'));
if isnan(newval),newval=0.0; set(handles.edit_vel0,'String',num2str(newval));end
handles.s(2) = newval;

% Update handles structure
guidata(h, handles);



% --------------------------------------------------------------------
function varargout = edit_mass_Callback(h, eventdata, handles, varargin)

newval = str2double(get(handles.edit_mass,'String'));
if isnan(newval),newval=1.0; set(handles.edit_mass,'String',num2str(newval));end
handles.M = newval;

% Update handles structure
guidata(h, handles);



% --------------------------------------------------------------------
function varargout = edit_stiffness_Callback(h, eventdata, handles, varargin)

newval = str2double(get(handles.edit_stiffness,'String'));
if isnan(newval),newval=1.0; set(handles.edit_stiffness,'String',num2str(newval));end
handles.k = newval;

% Update handles structure
guidata(h, handles);




% --------------------------------------------------------------------
function varargout = edit_damping_Callback(h, eventdata, handles, varargin)

newval = str2double(get(handles.edit_damping,'String'));
if isnan(newval),newval=1.0; set(handles.edit_damping,'String',num2str(newval));end
handles.r = newval;

% Update handles structure
guidata(h, handles);


% --------------------------------------------------------------------
function varargout = edit_Ft_Callback(h, eventdata, handles, varargin)

t = 0; x=0; v = 0;
mfun = get(handles.edit_Ft,'String');
eval([mfun,';'],'warndlg(lasterr)');

% Update handles structure
guidata(h, handles);


% --------------------------------------------------------------------
function varargout = edit_Ct_Callback(h, eventdata, handles, varargin)

t = 0;
mfun = get(handles.edit_Ct,'String');
eval([mfun,';'],'warndlg(lasterr)');

% Update handles structure
guidata(h, handles);